<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: MST_PersonaEmpleado.xml */
/* Generado: 2020-08-18 04:21:28 */

/* Mantenimiento de los registros de la tabla MST_PersonaEmpleado */
abstract class BaseMST_PersonaEmpleadoDP extends MST_PersonaEmpleadoBV
{
    /* Constructor ( Establece los valores desde un objeto MST_PersonaEmpleadoBN ) */
    public function __construct( MST_PersonaEmpleadoBN $o_MST_PersonaEmpleadoBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_MST_PersonaEmpleadoBN ) )
        {
            $this->setByBN( $o_MST_PersonaEmpleadoBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto MST_PersonaEmpleadoBN */
    public function setByBN( MST_PersonaEmpleadoBN $o_MST_PersonaEmpleadoBN )
    {
        if ( !is_null( $o_MST_PersonaEmpleadoBN->getIdPersona() ) )
        {
            $this->setIdPersona( $o_MST_PersonaEmpleadoBN->getIdPersona() );
        }
        if ( !is_null( $o_MST_PersonaEmpleadoBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_MST_PersonaEmpleadoBN->getIdCompania() );
        }
        if ( !is_null( $o_MST_PersonaEmpleadoBN->getIdSede() ) )
        {
            $this->setIdSede( $o_MST_PersonaEmpleadoBN->getIdSede() );
        }
        if ( !is_null( $o_MST_PersonaEmpleadoBN->getIdCargo() ) )
        {
            $this->setIdCargo( $o_MST_PersonaEmpleadoBN->getIdCargo() );
        }
        if ( !is_null( $o_MST_PersonaEmpleadoBN->getEmpleadoNombres() ) )
        {
            $this->setEmpleadoNombres( $o_MST_PersonaEmpleadoBN->getEmpleadoNombres() );
        }
        if ( !is_null( $o_MST_PersonaEmpleadoBN->getEmpleadoApellidoPaterno() ) )
        {
            $this->setEmpleadoApellidoPaterno( $o_MST_PersonaEmpleadoBN->getEmpleadoApellidoPaterno() );
        }
        if ( !is_null( $o_MST_PersonaEmpleadoBN->getEmpleadoApellidoMaterno() ) )
        {
            $this->setEmpleadoApellidoMaterno( $o_MST_PersonaEmpleadoBN->getEmpleadoApellidoMaterno() );
        }
        if ( !is_null( $o_MST_PersonaEmpleadoBN->getTipoDocumento() ) )
        {
            $this->setTipoDocumento( $o_MST_PersonaEmpleadoBN->getTipoDocumento() );
        }
        if ( !is_null( $o_MST_PersonaEmpleadoBN->getNumeroDocumento() ) )
        {
            $this->setNumeroDocumento( $o_MST_PersonaEmpleadoBN->getNumeroDocumento() );
        }
        if ( !is_null( $o_MST_PersonaEmpleadoBN->getSueldo() ) )
        {
            $this->setSueldo( $o_MST_PersonaEmpleadoBN->getSueldo() );
        }
        if ( !is_null( $o_MST_PersonaEmpleadoBN->getFechaInicio() ) )
        {
            $this->setFechaInicio( $o_MST_PersonaEmpleadoBN->getFechaInicio() );
        }
        if ( !is_null( $o_MST_PersonaEmpleadoBN->getFechaCese() ) )
        {
            $this->setFechaCese( $o_MST_PersonaEmpleadoBN->getFechaCese() );
        }
        if ( !is_null( $o_MST_PersonaEmpleadoBN->getFlagEstadoAsistencia() ) )
        {
            $this->setFlagEstadoAsistencia( $o_MST_PersonaEmpleadoBN->getFlagEstadoAsistencia() );
        }
        if ( !is_null( $o_MST_PersonaEmpleadoBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_MST_PersonaEmpleadoBN->getFechaCreacion() );
        }
        if ( !is_null( $o_MST_PersonaEmpleadoBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_MST_PersonaEmpleadoBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_MST_PersonaEmpleadoBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_MST_PersonaEmpleadoBN->getUsuarioModificacion() );
        }
        if ( !is_null( $o_MST_PersonaEmpleadoBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_MST_PersonaEmpleadoBN->getFechaModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_MST_PersonaEmpleadoFN = new MST_PersonaEmpleadoFN();
        $o_MST_PersonaEmpleadoBN = $o_MST_PersonaEmpleadoFN->selectByPk( $this->getIdPersona() );
        if ( is_null( $o_MST_PersonaEmpleadoBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO MST_PersonaEmpleado ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdPersona() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdPersona";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdPersona()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCompania";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSede() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdSede";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdSede()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCargo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCargo";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCargo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEmpleadoNombres() ) )
            {
                $s_SQLQuery1 .= $s_Separator."EmpleadoNombres";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEmpleadoNombres()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEmpleadoApellidoPaterno() ) )
            {
                $s_SQLQuery1 .= $s_Separator."EmpleadoApellidoPaterno";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEmpleadoApellidoPaterno()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEmpleadoApellidoMaterno() ) )
            {
                $s_SQLQuery1 .= $s_Separator."EmpleadoApellidoMaterno";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEmpleadoApellidoMaterno()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoDocumento() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TipoDocumento";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTipoDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNumeroDocumento() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NumeroDocumento";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNumeroDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSueldo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Sueldo";
                $s_SQLQuery2 .= $s_Separator."".$this->getSueldo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaInicio() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaInicio";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaInicio()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCese() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCese";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCese()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFlagEstadoAsistencia() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FlagEstadoAsistencia";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFlagEstadoAsistencia()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE MST_PersonaEmpleado SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery .= $s_Separator."IdCompania = ".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSede() ) )
            {
                $s_SQLQuery .= $s_Separator."IdSede = ".$this->getIdSede()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCargo() ) )
            {
                $s_SQLQuery .= $s_Separator."IdCargo = ".$this->getIdCargo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEmpleadoNombres() ) )
            {
                $s_SQLQuery .= $s_Separator."EmpleadoNombres = '".$this->getEmpleadoNombres()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEmpleadoApellidoPaterno() ) )
            {
                $s_SQLQuery .= $s_Separator."EmpleadoApellidoPaterno = '".$this->getEmpleadoApellidoPaterno()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEmpleadoApellidoMaterno() ) )
            {
                $s_SQLQuery .= $s_Separator."EmpleadoApellidoMaterno = '".$this->getEmpleadoApellidoMaterno()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoDocumento() ) )
            {
                $s_SQLQuery .= $s_Separator."TipoDocumento = '".$this->getTipoDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNumeroDocumento() ) )
            {
                $s_SQLQuery .= $s_Separator."NumeroDocumento = '".$this->getNumeroDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSueldo() ) )
            {
                $s_SQLQuery .= $s_Separator."Sueldo = ".$this->getSueldo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaInicio() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaInicio = '".$this->getFechaInicio()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCese() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCese = '".$this->getFechaCese()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFlagEstadoAsistencia() ) )
            {
                $s_SQLQuery .= $s_Separator."FlagEstadoAsistencia = '".$this->getFlagEstadoAsistencia()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdPersona = ".$this->getIdPersona().";";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM MST_PersonaEmpleado WHERE  IdPersona = ".$this->getIdPersona().";";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>